package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionMap_userImport) ENABLED START ***/
import java.util.stream.Collectors;
import java.util.Arrays;
import java.util.HashSet;
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionMap extends JNIObject implements IISLStandardMapMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLUnionMap(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionMap_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionMap build(long ptr) {
		return new ISLUnionMap(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionMap_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public ISLUnionSet getDomain() {
		return copy().domain();
	}
	
	public ISLUnionSet getRange() {
		return copy().range();
	}
	
	public ISLUnionMap getDomainMap() {
		return copy().domainMap();
	}
	
	public ISLUnionMap getRangeMap() {
		return copy().rangeMap();
	}

	public static ISLUnionMap buildFromMaps(List<ISLMap> maps) {
		ISLUnionMap res = ISLFactory.islUnionMap(maps.get(0).toString()); //ISLUnionMap.buildFromMaps(maps.get(0));
		for (int i = 1; i < maps.size(); i++) {
			res = res.addMap(maps.get(i).copy());
		}
		return res;
	}

	public static ISLUnionMap buildFromMaps(ISLMap... maps) {
		return buildFromMaps(Arrays.asList(maps));
	}

	public static ISLUnionMap unionAll(List<ISLUnionMap> maps) {
		if (maps.size() == 1) return maps.get(0);
		
		return maps.stream().reduce((m1,m2)->m1.union(m2)).get();
	}

	public static ISLUnionMap unionAll(ISLUnionMap... maps) {
		return unionAll(Arrays.asList(maps));
	}

	public static ISLUnionMap intersectAll(List<ISLUnionMap> maps) {
		return maps.stream().reduce((m1,m2)->m1.intersect(m2)).get();
	}

	public static ISLUnionMap intersectAll(ISLUnionMap... maps) {
		return intersectAll(Arrays.asList(maps));
	}

	public List<ISLMap> getMaps() {
		List<ISLMap> res = new ArrayList<ISLMap>();
		for (int i = 0; i < this.getNbMaps(); i++) {
			if (this.getMapAt(i) != null)
				res.add(this.getMapAt(i));
		}
		return res;
	}

	public List<ISLSet> getAllDomains() {
		return getMaps().stream().map(m->m.copy().getDomain()).collect(Collectors.toList());
	}

	public List<ISLSet> getAllRanges() {
		return getMaps().stream().map(m->m.copy().getRange()).collect(Collectors.toList());
	}

	public List<String> getAllInputTuples() {
		return getMaps().stream().map(m->m.getInputTupleName()).collect(Collectors.toList());
	}

	public List<String> getAllOutputTuples() {
		return getMaps().stream().map(m->m.getOutputTupleName()).collect(Collectors.toList());
	}

	/**
	 * Simplify a given union map by removing all the constraints that can be added
	 * using domains information.
	 * 
	 * @param umap
	 *            the input union map
	 * @param uset
	 *            the context domains
	 * @return simplified union map
	 */
	public ISLUnionMap simplify(ISLUnionSet uset) {
		ISLUnionMap context = null;
		ISLUnionSet domains = uset.copy();
		for (ISLSet set : domains.copy().getSets()) {
			for (ISLSet set2 : domains.copy().getSets()) {
				ISLMap m = ISLMap.buildFromDomainAndRange(set.copy(),
						ISLSet.buildUniverse(set2.getSpace()));
				ISLUnionMap umap2 = m.toUnionMap();
				if (context == null)
					context = umap2;
				else
					context = context.union(umap2);
			}
		}
		ISLUnionMap sumap = this.gist(context).coalesce();
		return sumap;
	}
	 
	public String toMultiLineString() {
		return this.toString().replace(";",";\n").replace("{", "{\n").replace("{}", "}\n");
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_map_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLUnionMap buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_union_map_read_from_str) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLUnionMap buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_union_map_empty) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_universe 
	 * 
	@take umap
	 * @generated
	**/
	 public static ISLUnionMap buildUniverse(ISLUnionMap umap) { 
		/*** PROTECTED REGION ID(static_isl_union_map_universe) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(umap);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_universe(getNativePtr(umap)));
			} finally {
				taken(umap);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_from_domain 
	 * 
	@take uset
	 * @generated
	**/
	 public static ISLUnionMap buildFromDomain(ISLUnionSet uset) { 
		/*** PROTECTED REGION ID(static_isl_union_map_from_domain) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_domain(getNativePtr(uset)));
			} finally {
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_from_range 
	 * 
	@take uset
	 * @generated
	**/
	 public static ISLUnionMap buildFromRange(ISLUnionSet uset) { 
		/*** PROTECTED REGION ID(static_isl_union_map_from_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_range(getNativePtr(uset)));
			} finally {
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_from_domain_and_range 
	 * 
	@take domain range
	 * @generated
	**/
	 public static ISLUnionMap buildFromDomainAndRange(ISLUnionSet domain, ISLUnionSet range) { 
		/*** PROTECTED REGION ID(static_isl_union_map_from_domain_and_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(domain, range);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_domain_and_range(getNativePtr(domain), getNativePtr(range)));
			} finally {
				taken(domain);
				taken(range);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionMap map, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_map_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_to_string(getNativePtr(map), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_map_from_union_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMap toMap() {
		/*** PROTECTED REGION ID(isl_map_from_union_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMap.build(ISLNative.isl_map_from_union_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_union_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff toMultiUnionPWAff() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_from_union_map) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_union_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_union_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff toUnionPWMultiAff() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_from_union_map) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_union_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_map_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_map_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_map_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_map_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_copy 
	 * 
	 * @generated
	**/
	public ISLUnionMap copy() {
		/*** PROTECTED REGION ID(isl_union_map_copy) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_map_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_map_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_n_map 
	 * 
	 * @generated
	**/
	public int getNbMaps() {
		/*** PROTECTED REGION ID(isl_union_map_n_map) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_n_map(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_compute_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap computeDivs() {
		/*** PROTECTED REGION ID(isl_union_map_compute_divs) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_compute_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_extract_map 
	 * 
	 * @take space
	 * @generated
	**/
	public ISLMap extractMap(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_union_map_extract_map) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMap.build(ISLNative.isl_union_map_extract_map(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_get_dim_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_union_map_get_dim_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_union_map_get_dim_id(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_union_map_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_union_map_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_bijective 
	 * 
	 * @generated
	**/
	public boolean isBijective() {
		/*** PROTECTED REGION ID(isl_union_map_is_bijective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_bijective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_injective 
	 * 
	 * @generated
	**/
	public boolean isInjective() {
		/*** PROTECTED REGION ID(isl_union_map_is_injective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_injective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_single_valued 
	 * 
	 * @generated
	**/
	public boolean isSingleValued() {
		/*** PROTECTED REGION ID(isl_union_map_is_single_valued) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_single_valued(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_plain_is_injective 
	 * 
	 * @generated
	**/
	public boolean isPlainInjective() {
		/*** PROTECTED REGION ID(isl_union_map_plain_is_injective) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_plain_is_injective(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_equal(getNativePtr(this), getNativePtr(umap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_subset(getNativePtr(this), getNativePtr(umap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_is_strict_subset 
	 * 
	 * @generated
	**/
	public boolean isStrictSubset(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_is_strict_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_map_is_strict_subset(getNativePtr(this), getNativePtr(umap2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet params() {
		/*** PROTECTED REGION ID(isl_union_map_params) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_union_map_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_reverse 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap reverse() {
		/*** PROTECTED REGION ID(isl_union_map_reverse) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_reverse(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_union_map_project_out) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_union_map_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_map_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet range() {
		/*** PROTECTED REGION ID(isl_union_map_range) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_map_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_domain_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap domainMap() {
		/*** PROTECTED REGION ID(isl_union_map_domain_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_domain_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_range_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap rangeMap() {
		/*** PROTECTED REGION ID(isl_union_map_range_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_range_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_deltas 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet deltas() {
		/*** PROTECTED REGION ID(isl_union_map_deltas) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_map_deltas(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_deltas_map 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap deltasMap() {
		/*** PROTECTED REGION ID(isl_union_map_deltas_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_deltas_map(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap coalesce() {
		/*** PROTECTED REGION ID(isl_union_map_coalesce) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap detectEqualities() {
		/*** PROTECTED REGION ID(isl_union_map_detect_equalities) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap affineHull() {
		/*** PROTECTED REGION ID(isl_union_map_affine_hull) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_polyhedral_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap polyhedralHull() {
		/*** PROTECTED REGION ID(isl_union_map_polyhedral_hull) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_polyhedral_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_simple_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap simpleHull() {
		/*** PROTECTED REGION ID(isl_union_map_simple_hull) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_simple_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_power 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap parametricPower(JNIPtrBoolean exact) {
		/*** PROTECTED REGION ID(isl_union_map_power) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_power(getNativePtr(this), exact));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_fixed_power_val 
	 * 
	 * @take this exp
	 * @generated
	**/
	public ISLUnionMap power(ISLVal exp) {
		/*** PROTECTED REGION ID(isl_union_map_fixed_power_val) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, exp);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_fixed_power_val(getNativePtr(this), getNativePtr(exp)));
			} finally {
				taken(this);
				taken(exp);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_transitive_closure 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap transitiveClosure(JNIPtrBoolean exact) {
		/*** PROTECTED REGION ID(isl_union_map_transitive_closure) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_transitive_closure(getNativePtr(this), exact));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_wrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet wrap() {
		/*** PROTECTED REGION ID(isl_union_map_wrap) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_map_wrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_zip 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap zip() {
		/*** PROTECTED REGION ID(isl_union_map_zip) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_zip(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap curry() {
		/*** PROTECTED REGION ID(isl_union_map_curry) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_uncurry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap uncurry() {
		/*** PROTECTED REGION ID(isl_union_map_uncurry) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_uncurry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_range_curry 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap rangeCurry() {
		/*** PROTECTED REGION ID(isl_union_map_range_curry) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_range_curry(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_add_map 
	 * 
	 * @take this map
	 * @generated
	**/
	public ISLUnionMap addMap(ISLMap map) {
		/*** PROTECTED REGION ID(isl_union_map_add_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, map);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_add_map(getNativePtr(this), getNativePtr(map)));
			} finally {
				taken(this);
				taken(map);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionMap intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_map_intersect_params) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionMap intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_map_intersect_domain) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_intersect_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionMap intersectRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_map_intersect_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_intersect_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_intersect 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap intersect(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_intersect) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_intersect(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_union 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap union(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_union) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_union(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_subtract 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap subtract(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_subtract) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_subtract(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_subtract_domain 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLUnionMap subtractDomain(ISLUnionSet dom) {
		/*** PROTECTED REGION ID(isl_union_map_subtract_domain) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_subtract_domain(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_subtract_range 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLUnionMap subtractRange(ISLUnionSet dom) {
		/*** PROTECTED REGION ID(isl_union_map_subtract_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_subtract_range(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_apply_domain 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap applyDomain(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_apply_domain) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_apply_domain(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_apply_range 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap applyRange(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_apply_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_apply_range(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_domain_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLUnionMap preimageDomain(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_domain_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_domain_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_domain_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLUnionMap preimageDomain(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_domain_pw_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_domain_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_domain_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLUnionMap preimageDomain(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_domain_union_pw_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_domain_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_range_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLUnionMap preimageRange(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_range_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_range_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_range_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLUnionMap preimageRange(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_range_pw_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_range_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_preimage_range_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLUnionMap preimageRange(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_union_map_preimage_range_union_pw_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_preimage_range_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionMap gist(ISLUnionMap context) {
		/*** PROTECTED REGION ID(isl_union_map_gist) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_gist_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionMap gistParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_map_gist_params) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_gist_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_gist_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionMap gistDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_map_gist_domain) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_gist_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_gist_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionMap gistRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_map_gist_range) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_gist_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap lexMin() {
		/*** PROTECTED REGION ID(isl_union_map_lexmin) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap lexMax() {
		/*** PROTECTED REGION ID(isl_union_map_lexmax) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lex_lt_union_map 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap lexLT(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_lex_lt_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lex_lt_union_map(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lex_le_union_map 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap lexLE(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_lex_le_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lex_le_union_map(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lex_gt_union_map 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap lexGT(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_lex_gt_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lex_gt_union_map(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_lex_ge_union_map 
	 * 
	 * @take this umap2
	 * @generated
	**/
	public ISLUnionMap lexGE(ISLUnionMap umap2) {
		/*** PROTECTED REGION ID(isl_union_map_lex_ge_union_map) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this, umap2);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_lex_ge_union_map(getNativePtr(this), getNativePtr(umap2)));
			} finally {
				taken(this);
				taken(umap2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_map_get_map_at 
	 * 
	 * @generated
	**/
	public ISLMap getMapAt(int pos) {
		/*** PROTECTED REGION ID(isl_union_map_get_map_at) DISABLED START ***/
		ISLMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMap.build(ISLNative.isl_union_map_get_map_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionMap_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
